/[gentoo-x86]/eclass/distutils.eclass
Gentoo

Diff of /eclass/distutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.66 Revision 1.71
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/distutils.eclass,v 1.66 2009/11/06 00:35:30 arfrever Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/distutils.eclass,v 1.71 2010/02/07 21:17:15 pva Exp $
4 4
5# @ECLASS: distutils.eclass 5# @ECLASS: distutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# <python@gentoo.org> 7# Gentoo Python Project <python@gentoo.org>
8# 8#
9# Original author: Jon Nelson <jnelson@gentoo.org> 9# Original author: Jon Nelson <jnelson@gentoo.org>
10# @BLURB: This eclass allows easier installation of distutils-based python modules 10# @BLURB: Eclass for packages with build systems using Distutils
11# @DESCRIPTION: 11# @DESCRIPTION:
12# The distutils eclass is designed to allow easier installation of 12# The distutils eclass defines phase functions for packages with build systems using Distutils
13# distutils-based python modules and their incorporation into
14# the Gentoo Linux system.
15 13
16inherit eutils multilib python 14inherit eutils multilib python
17 15
18case "${EAPI:-0}" in 16case "${EAPI:-0}" in
19 0|1) 17 0|1)
22 *) 20 *)
23 EXPORT_FUNCTIONS src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm 21 EXPORT_FUNCTIONS src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm
24 ;; 22 ;;
25esac 23esac
26 24
27if [[ -z "${DISTUTILS_DISABLE_PYTHON_DEPENDENCY}" ]]; then 25if [[ -z "${PYTHON_DEPEND}" ]]; then
28 DEPEND="virtual/python" 26 DEPEND="virtual/python"
29 RDEPEND="${DEPEND}" 27 RDEPEND="${DEPEND}"
30fi 28fi
29
30if has "${EAPI:-0}" 0 1 2; then
31python="python" 31 python="python"
32else
33 # Use "$(PYTHON)" or "$(PYTHON -A)" instead of "${python}".
34 python="die"
35fi
32 36
33# @ECLASS-VARIABLE: DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES 37# @ECLASS-VARIABLE: DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES
34# @DESCRIPTION: 38# @DESCRIPTION:
35# Set this to use separate source directories for each enabled version of Python. 39# Set this to use separate source directories for each enabled version of Python.
36 40
37# @ECLASS-VARIABLE: DISTUTILS_GLOBAL_OPTIONS 41# @ECLASS-VARIABLE: DISTUTILS_GLOBAL_OPTIONS
38# @DESCRIPTION: 42# @DESCRIPTION:
39# Global options passed to setup.py. 43# Global options passed to setup.py.
40 44
45# @ECLASS-VARIABLE: DISTUTILS_SRC_TEST
46# @DESCRIPTION:
47# Type of test command used by distutils_src_test().
48# IUSE and DEPEND are automatically adjusted, unless DISTUTILS_DISABLE_TEST_DEPENDENCY is set.
49# Valid values:
50# setup.py
51# nosetests
52# py.test
53# trial [arguments]
54
55# @ECLASS-VARIABLE: DISTUTILS_DISABLE_TEST_DEPENDENCY
56# @DESCRIPTION:
57# Disable modification of IUSE and DEPEND caused by setting of DISTUTILS_SRC_TEST.
58
59if [[ -n "${DISTUTILS_SRC_TEST}" && ! "${DISTUTILS_SRC_TEST}" =~ ^(setup\.py|nosetests|py\.test|trial(\ .*)?)$ ]]; then
60 die "'DISTUTILS_SRC_TEST' variable has unsupported value '${DISTUTILS_SRC_TEST}'"
61fi
62
63if [[ -z "${DISTUTILS_DISABLE_TEST_DEPENDENCY}" ]]; then
64 if [[ "${DISTUTILS_SRC_TEST}" == "nosetests" ]]; then
65 IUSE="test"
66 DEPEND+="${DEPEND:+ }test? ( dev-python/nose )"
67 elif [[ "${DISTUTILS_SRC_TEST}" == "py.test" ]]; then
68 IUSE="test"
69 DEPEND+="${DEPEND:+ }test? ( dev-python/py )"
70 # trial requires an argument, which is usually equal to "${PN}".
71 elif [[ "${DISTUTILS_SRC_TEST}" =~ ^trial(\ .*)?$ ]]; then
72 IUSE="test"
73 DEPEND+="${DEPEND:+ }test? ( dev-python/twisted )"
74 fi
75fi
76
77if [[ -n "${DISTUTILS_SRC_TEST}" ]]; then
78 EXPORT_FUNCTIONS src_test
79fi
80
81# @ECLASS-VARIABLE: DISTUTILS_DISABLE_VERSIONING_OF_PYTHON_SCRIPTS
82# @DESCRIPTION:
83# Set this to disable renaming of Python scripts containing versioned shebangs
84# and generation of wrapper scripts.
85
41# @ECLASS-VARIABLE: DOCS 86# @ECLASS-VARIABLE: DOCS
42# @DESCRIPTION: 87# @DESCRIPTION:
43# Additional DOCS 88# Additional documentation files installed by distutils_src_install().
89
90_distutils_get_build_dir() {
91 if [[ -n "${SUPPORT_PYTHON_ABIS}" && -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]]; then
92 echo "build-${PYTHON_ABI}"
93 else
94 echo "build"
95 fi
96}
97
98_distutils_get_PYTHONPATH() {
99 if [[ -n "${SUPPORT_PYTHON_ABIS}" && -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]]; then
100 ls -d build-${PYTHON_ABI}/lib* 2> /dev/null
101 else
102 ls -d build/lib* 2> /dev/null
103 fi
104}
105
106_distutils_hook() {
107 if [[ "$#" -ne 1 ]]; then
108 die "${FUNCNAME}() requires 1 argument"
109 fi
110 if [[ "$(type -t "distutils_src_${EBUILD_PHASE}_$1_hook")" == "function" ]]; then
111 "distutils_src_${EBUILD_PHASE}_$1_hook"
112 fi
113}
44 114
45# @FUNCTION: distutils_src_unpack 115# @FUNCTION: distutils_src_unpack
46# @DESCRIPTION: 116# @DESCRIPTION:
47# The distutils src_unpack function, this function is exported 117# The distutils src_unpack function. This function is exported.
48distutils_src_unpack() { 118distutils_src_unpack() {
49 if [[ "${EBUILD_PHASE}" != "unpack" ]]; then 119 if [[ "${EBUILD_PHASE}" != "unpack" ]]; then
50 die "${FUNCNAME}() can be used only in src_unpack() phase" 120 die "${FUNCNAME}() can be used only in src_unpack() phase"
51 fi 121 fi
52 122
56 has "${EAPI:-0}" 0 1 && distutils_src_prepare 126 has "${EAPI:-0}" 0 1 && distutils_src_prepare
57} 127}
58 128
59# @FUNCTION: distutils_src_prepare 129# @FUNCTION: distutils_src_prepare
60# @DESCRIPTION: 130# @DESCRIPTION:
61# The distutils src_prepare function, this function is exported 131# The distutils src_prepare function. This function is exported.
62distutils_src_prepare() { 132distutils_src_prepare() {
63 if ! has "${EAPI:-0}" 0 1 && [[ "${EBUILD_PHASE}" != "prepare" ]]; then 133 if ! has "${EAPI:-0}" 0 1 && [[ "${EBUILD_PHASE}" != "prepare" ]]; then
64 die "${FUNCNAME}() can be used only in src_prepare() phase" 134 die "${FUNCNAME}() can be used only in src_prepare() phase"
65 fi 135 fi
66 136
67 # Delete ez_setup files to prevent packages from installing 137 # Delete ez_setup files to prevent packages from installing Setuptools on their own.
68 # Setuptools on their own.
69 local ez_setup_existence="0" 138 local ez_setup_existence="0"
70 [[ -d ez_setup || -f ez_setup.py ]] && ez_setup_existence="1" 139 [[ -d ez_setup || -f ez_setup.py ]] && ez_setup_existence="1"
71 rm -fr ez_setup* 140 rm -fr ez_setup*
72 if [[ "${ez_setup_existence}" == "1" ]]; then 141 if [[ "${ez_setup_existence}" == "1" ]]; then
73 echo "def use_setuptools(*args, **kwargs): pass" > ez_setup.py 142 echo "def use_setuptools(*args, **kwargs): pass" > ez_setup.py
74 fi 143 fi
75 144
76 # Delete distribute_setup files to prevent packages from installing 145 # Delete distribute_setup files to prevent packages from installing Distribute on their own.
77 # Distribute on their own.
78 local distribute_setup_existence="0" 146 local distribute_setup_existence="0"
79 [[ -d distribute_setup || -f distribute_setup.py ]] && distribute_setup_existence="1" 147 [[ -d distribute_setup || -f distribute_setup.py ]] && distribute_setup_existence="1"
80 rm -fr distribute_setup* 148 rm -fr distribute_setup*
81 if [[ "${distribute_setup_existence}" == "1" ]]; then 149 if [[ "${distribute_setup_existence}" == "1" ]]; then
82 echo "def use_setuptools(*args, **kwargs): pass" > distribute_setup.py 150 echo "def use_setuptools(*args, **kwargs): pass" > distribute_setup.py
87 fi 155 fi
88} 156}
89 157
90# @FUNCTION: distutils_src_compile 158# @FUNCTION: distutils_src_compile
91# @DESCRIPTION: 159# @DESCRIPTION:
92# The distutils src_compile function, this function is exported 160# The distutils src_compile function. This function is exported.
161# In ebuilds of packages supporting installation for multiple versions of Python, this function
162# calls distutils_src_compile_pre_hook() and distutils_src_compile_post_hook(), if they are defined.
93distutils_src_compile() { 163distutils_src_compile() {
94 if [[ "${EBUILD_PHASE}" != "compile" ]]; then 164 if [[ "${EBUILD_PHASE}" != "compile" ]]; then
95 die "${FUNCNAME}() can be used only in src_compile() phase" 165 die "${FUNCNAME}() can be used only in src_compile() phase"
96 fi 166 fi
97 167
98 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 168 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
99 if [[ -n "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]]; then 169 distutils_building() {
100 building() { 170 _distutils_hook pre
171
172 echo "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build -b "$(_distutils_get_build_dir)" "$@"
173 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build -b "$(_distutils_get_build_dir)" "$@" || return "$?"
174
175 _distutils_hook post
176 }
177 python_execute_function ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} distutils_building "$@"
178 else
101 echo "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build "$@" 179 echo "$(PYTHON -A)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build "$@"
102 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build "$@" 180 "$(PYTHON -A)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build "$@" || die "Building failed"
181 fi
182}
183
184# @FUNCTION: distutils_src_test
185# @DESCRIPTION:
186# The distutils src_test function. This function is exported, when DISTUTILS_SRC_TEST variable is set.
187distutils_src_test() {
188 if [[ "${DISTUTILS_SRC_TEST}" == "setup.py" ]]; then
189 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
190 distutils_testing() {
191 echo PYTHONPATH="$(_distutils_get_PYTHONPATH)" "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" $([[ -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]] && echo build -b "$(_distutils_get_build_dir)") test "$@"
192 PYTHONPATH="$(_distutils_get_PYTHONPATH)" "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" $([[ -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]] && echo build -b "$(_distutils_get_build_dir)") test "$@"
103 } 193 }
104 python_execute_function -s building "$@" 194 python_execute_function ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} distutils_testing "$@"
105 else 195 else
106 building() { 196 echo PYTHONPATH="$(_distutils_get_PYTHONPATH)" "$(PYTHON -A)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" test "$@" || die "Testing failed"
107 echo "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build -b "build-${PYTHON_ABI}" "$@" 197 PYTHONPATH="$(_distutils_get_PYTHONPATH)" "$(PYTHON -A)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" test "$@" || die "Testing failed"
108 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build -b "build-${PYTHON_ABI}" "$@"
109 }
110 python_execute_function building "$@"
111 fi 198 fi
199 elif [[ "${DISTUTILS_SRC_TEST}" == "nosetests" ]]; then
200 python_execute_nosetests -P '$(_distutils_get_PYTHONPATH)' ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} -- "$@"
201 elif [[ "${DISTUTILS_SRC_TEST}" == "py.test" ]]; then
202 python_execute_py.test -P '$(_distutils_get_PYTHONPATH)' ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} -- "$@"
203 # trial requires an argument, which is usually equal to "${PN}".
204 elif [[ "${DISTUTILS_SRC_TEST}" =~ ^trial(\ .*)?$ ]]; then
205 local trial_arguments
206 if [[ "${DISTUTILS_SRC_TEST}" == "trial "* ]]; then
207 trial_arguments="${DISTUTILS_SRC_TEST#trial }"
112 else 208 else
113 echo ${python} setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build "$@" 209 trial_arguments="${PN}"
114 ${python} setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build "$@" || die "Building failed" 210 fi
211
212 python_execute_trial -P '$(_distutils_get_PYTHONPATH)' ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} -- ${trial_arguments} "$@"
213 else
214 die "'DISTUTILS_SRC_TEST' variable has unsupported value '${DISTUTILS_SRC_TEST}'"
115 fi 215 fi
116} 216}
117 217
118# @FUNCTION: distutils_src_install 218# @FUNCTION: distutils_src_install
119# @DESCRIPTION: 219# @DESCRIPTION:
120# The distutils src_install function, this function is exported. 220# The distutils src_install function. This function is exported.
121# It also installs the "standard docs" (CHANGELOG, Change*, KNOWN_BUGS, MAINTAINERS, 221# In ebuilds of packages supporting installation for multiple versions of Python, this function
122# PKG-INFO, CONTRIBUTORS, TODO, NEWS, MANIFEST*, README*, and AUTHORS) 222# calls distutils_src_install_pre_hook() and distutils_src_install_post_hook(), if they are defined.
223# It also installs some standard documentation files (AUTHORS, Change*, CHANGELOG, CONTRIBUTORS,
224# KNOWN_BUGS, MAINTAINERS, MANIFEST*, NEWS, PKG-INFO, README*, TODO).
123distutils_src_install() { 225distutils_src_install() {
124 if [[ "${EBUILD_PHASE}" != "install" ]]; then 226 if [[ "${EBUILD_PHASE}" != "install" ]]; then
125 die "${FUNCNAME}() can be used only in src_install() phase" 227 die "${FUNCNAME}() can be used only in src_install() phase"
126 fi 228 fi
127 229
128 local pylibdir
129
130 # Mark the package to be rebuilt after a python upgrade.
131 python_need_rebuild
132
133 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 230 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
134 if [[ -n "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]]; then 231 if [[ -z "${DISTUTILS_DISABLE_VERSIONING_OF_PYTHON_SCRIPTS}" && "${BASH_VERSINFO[0]}" -ge 4 ]]; then
135 installation() { 232 declare -A wrapper_scripts=()
136 # need this for python-2.5 + setuptools in cases where
137 # a package uses distutils but does not install anything
138 # in site-packages. (eg. dev-java/java-config-2.x)
139 # - liquidx (14/08/2006)
140 pylibdir="$("$(PYTHON)" -c 'from distutils.sysconfig import get_python_lib; print(get_python_lib())')"
141 [[ -n "${pylibdir}" ]] && dodir "${pylibdir}"
142 233
143 echo "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" install --root="${D}" --no-compile "$@" 234 rename_scripts_with_versioned_shebangs() {
144 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" install --root="${D}" --no-compile "$@" 235 if [[ -d "${D}usr/bin" ]]; then
236 cd "${D}usr/bin"
237
238 local file
239 for file in *; do
240 if [[ -f "${file}" && ! "${file}" =~ [[:digit:]]+\.[[:digit:]]+$ && "$(head -n1 "${file}")" =~ ^'#!'.*python[[:digit:]]+\.[[:digit:]]+ ]]; then
241 mv "${file}" "${file}-${PYTHON_ABI}" || die "Renaming of '${file}' failed"
242 wrapper_scripts+=(["${D}usr/bin/${file}"]=)
243 fi
244 done
245 fi
145 } 246 }
146 python_execute_function -s installation "$@" 247 fi
248
249 distutils_installation() {
250 _distutils_hook pre
251
252 echo "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" $([[ -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]] && echo build -b "$(_distutils_get_build_dir)") install --root="${D}" --no-compile "$@"
253 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" $([[ -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]] && echo build -b "$(_distutils_get_build_dir)") install --root="${D}" --no-compile "$@" || return "$?"
254
255 if [[ -z "${DISTUTILS_DISABLE_VERSIONING_OF_PYTHON_SCRIPTS}" && "${BASH_VERSINFO[0]}" -ge 4 ]]; then
256 rename_scripts_with_versioned_shebangs
257 fi
258
259 _distutils_hook post
260 }
261 python_execute_function ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} distutils_installation "$@"
262
263 if [[ -z "${DISTUTILS_DISABLE_VERSIONING_OF_PYTHON_SCRIPTS}" && "${#wrapper_scripts[@]}" -ne 0 && "${BASH_VERSINFO[0]}" -ge 4 ]]; then
264 python_generate_wrapper_scripts "${!wrapper_scripts[@]}"
265 fi
266 unset wrapper_scripts
147 else 267 else
148 installation() { 268 # Mark the package to be rebuilt after a Python upgrade.
149 # need this for python-2.5 + setuptools in cases where 269 python_need_rebuild
150 # a package uses distutils but does not install anything
151 # in site-packages. (eg. dev-java/java-config-2.x)
152 # - liquidx (14/08/2006)
153 pylibdir="$("$(PYTHON)" -c 'from distutils.sysconfig import get_python_lib; print(get_python_lib())')"
154 [[ -n "${pylibdir}" ]] && dodir "${pylibdir}"
155 270
156 echo "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build -b "build-${PYTHON_ABI}" install --root="${D}" --no-compile "$@"
157 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build -b "build-${PYTHON_ABI}" install --root="${D}" --no-compile "$@"
158 }
159 python_execute_function installation "$@"
160 fi
161 else
162 # need this for python-2.5 + setuptools in cases where
163 # a package uses distutils but does not install anything
164 # in site-packages. (eg. dev-java/java-config-2.x)
165 # - liquidx (14/08/2006)
166 pylibdir="$(${python} -c 'from distutils.sysconfig import get_python_lib; print(get_python_lib())')"
167 [[ -n "${pylibdir}" ]] && dodir "${pylibdir}"
168
169 echo ${python} setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" install --root="${D}" --no-compile "$@" 271 echo "$(PYTHON -A)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" install --root="${D}" --no-compile "$@"
170 ${python} setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" install --root="${D}" --no-compile "$@" || die "Installation failed" 272 "$(PYTHON -A)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" install --root="${D}" --no-compile "$@" || die "Installation failed"
171 fi 273 fi
172 274
173 if [[ -e "${D}usr/local" ]]; then 275 if [[ -e "${D}usr/local" ]]; then
174 die "Illegal installation into /usr/local" 276 die "Illegal installation into /usr/local"
175 fi 277 fi
187 fi 289 fi
188} 290}
189 291
190# @FUNCTION: distutils_pkg_postinst 292# @FUNCTION: distutils_pkg_postinst
191# @DESCRIPTION: 293# @DESCRIPTION:
192# This is a generic optimization, you should override it if your package 294# The distutils pkg_postinst function. This function is exported.
193# installs modules in another directory. This function is exported. 295# When PYTHON_MODNAME variable is set, then this function calls python_mod_optimize() with modules
296# specified in PYTHON_MODNAME variable. Otherwise it calls python_mod_optimize() with module, whose
297# name is equal to name of current package, if this module exists.
194distutils_pkg_postinst() { 298distutils_pkg_postinst() {
195 if [[ "${EBUILD_PHASE}" != "postinst" ]]; then 299 if [[ "${EBUILD_PHASE}" != "postinst" ]]; then
196 die "${FUNCNAME}() can be used only in pkg_postinst() phase" 300 die "${FUNCNAME}() can be used only in pkg_postinst() phase"
197 fi 301 fi
198 302
214 fi 318 fi
215} 319}
216 320
217# @FUNCTION: distutils_pkg_postrm 321# @FUNCTION: distutils_pkg_postrm
218# @DESCRIPTION: 322# @DESCRIPTION:
219# Generic pyc/pyo cleanup script. This function is exported. 323# The distutils pkg_postrm function. This function is exported.
324# When PYTHON_MODNAME variable is set, then this function calls python_mod_cleanup() with modules
325# specified in PYTHON_MODNAME variable. Otherwise it calls python_mod_cleanup() with module, whose
326# name is equal to name of current package, if this module exists.
220distutils_pkg_postrm() { 327distutils_pkg_postrm() {
221 if [[ "${EBUILD_PHASE}" != "postrm" ]]; then 328 if [[ "${EBUILD_PHASE}" != "postrm" ]]; then
222 die "${FUNCNAME}() can be used only in pkg_postrm() phase" 329 die "${FUNCNAME}() can be used only in pkg_postrm() phase"
223 fi 330 fi
224 331
248 fi 355 fi
249} 356}
250 357
251# @FUNCTION: distutils_python_version 358# @FUNCTION: distutils_python_version
252# @DESCRIPTION: 359# @DESCRIPTION:
253# Calls python_version, so that you can use something like 360# Deprecated wrapper function for deprecated python_version().
254# e.g. insinto ${ROOT}/usr/include/python${PYVER}
255distutils_python_version() { 361distutils_python_version() {
362 if ! has "${EAPI:-0}" 0 1 2; then
363 eerror "Use PYTHON() and/or python_get_*() instead of ${FUNCNAME}()."
364 die "${FUNCNAME}() cannot be used in this EAPI"
365 fi
366
256 python_version 367 python_version
257} 368}
258 369
259# @FUNCTION: distutils_python_tkinter 370# @FUNCTION: distutils_python_tkinter
260# @DESCRIPTION: 371# @DESCRIPTION:
261# Checks for if tkinter support is compiled into python 372# Deprecated wrapper function for python_tkinter_exists().
262distutils_python_tkinter() { 373distutils_python_tkinter() {
374 if ! has "${EAPI:-0}" 0 1 2; then
375 eerror "Use python_tkinter_exists() instead of ${FUNCNAME}()."
376 die "${FUNCNAME}() cannot be used in this EAPI"
377 fi
378
263 python_tkinter_exists 379 python_tkinter_exists
264} 380}

Legend:
Removed from v.1.66  
changed lines
  Added in v.1.71

  ViewVC Help
Powered by ViewVC 1.1.20